/* +-----------------------------------------------------------------+
   | (C) SELIAtec S.A.                                               |
   +-----------------------------------------------------------------+
   | Tel :  88 86 68 54                                              |
   | Fax :  88 86 74 76                                              |
   +-------------------------------+---------------------------------+
   | Projet   : CF01               |     Compilateur : Visual C++    |
   | Nom      : cf01.c             |     Version     : 4.00 WIN32    |
   +-------------------------------+---------------------------------|
   | Auteur    : Frank Diebolt     |     Date       : 28 Mai 1997    |
   +-------------------------------+---------------------------------+
   | Descript. :                                                     |
   |                                                                 |
   +-----------------------------------------------------------------+
   |                         MISES A JOUR	  												 |
   +----------+-----------+------------------------------------------+
   |   Date   |   Auteur  |          Description des mises  jour		 |
   +----------+-----------+------------------------------------------+
   |5/05/94   |F. SANJARI | Cration V 1.00                          |
   +----------+-----------+------------------------------------------+
   |24/07/95  |JM. HILAIRE| Mise  jour                              |
   +----------+-----------+------------------------------------------+
   |24/06/96  |F. GLOHR   | Mise  jour                              |
   +----------|-----------+------------------------------------------+ 
   |11/04/97  |F. GLOHR   | Modification pour la nouvelle MA03N      |
   +----------|-----------+------------------------------------------+ 
   |20/05/97  |F. DIEBOLT | Modification pour windows 32 (win 95/NT) |
   +----------|-----------+------------------------------------------+ */

#include <windows.h>
#include <dos.h>
#include <stdio.h>
#include <stddef.h>
#include "cf01.h"
#include <stdlib.h>

#ifdef WIN32
#ifndef WINNT
#include <conio.h>
#pragma intrinsic(outp,inp,outpw,inpw)
#endif
#endif

#ifdef WINNT		//------------------------------------------------

#include <winioctl.h>
#include "..\ioCF01.h" 

#define CARD_MAX_NAME			32
#define CF01_AMOUNT				8
#define CF01_SLOT_AMOUNT	4
#define SERVICE_NAME			"Cf01"
#define CARD_DEFAULT_ADR	0x300
#define CARD_DEFAULT_LEN	4
#define VIDE							"vide"

HANDLE  hndFileRead[CF01_AMOUNT]; 
HANDLE  hndFileWrite[CF01_AMOUNT];

#define MAX_PORT_NUMBER	65536
HANDLE	port_number_read[MAX_PORT_NUMBER];
HANDLE	port_number_write[MAX_PORT_NUMBER];

typedef struct _LOG_DEVICE_CONFIGURATION {
	char module_name[CF01_SLOT_AMOUNT][CARD_MAX_NAME];
	DWORD io_start;
	DWORD io_length;
} LOG_DEVICE_CONFIGURATION;

static LOG_DEVICE_CONFIGURATION CF01Card[CF01_AMOUNT];
#define SERVICES_KEY	"SYSTEM\\CurrentControlSet\\Services"

#endif	//------------------------------------------------

#ifdef WIN32		// Point d'entre de la DLL pour Win95 et WinNT
static int users=0;

//+-----------------------------------------------------------------+
BOOL WINAPI DllMain (HANDLE hInst,ULONG ul_reason_for_call,LPVOID lpReserved)
{
#ifdef WINNT
	BOOL activ_slot;
	DWORD p,log;
	char KeyName[1024];
	HKEY new_key;
	DWORD io_start,io_length,slot;
	char complete_key[1024];
	char log_str[32];
	char file_name[64];
	
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
			users++;
			break;
		case DLL_PROCESS_DETACH:
		case DLL_THREAD_DETACH:
			users--;
			if (users==0) {
				for (log=0; log<CF01_AMOUNT; log++) {
					if (hndFileRead[log]!=INVALID_HANDLE_VALUE) CloseHandle(hndFileRead[log]);
					if (hndFileWrite[log]!=INVALID_HANDLE_VALUE) CloseHandle(hndFileWrite[log]);
				}
				return TRUE;
			}
	}

	for (p=0; p<MAX_PORT_NUMBER; p++) {
		port_number_read[p]=INVALID_HANDLE_VALUE;
		port_number_write[p]=INVALID_HANDLE_VALUE;
	}

	strcpy(KeyName,SERVICES_KEY);
	strcat(KeyName,"\\");
	strcat(KeyName,SERVICE_NAME);
	strcat(KeyName,"\\Cartes\\");

	for (log=0; log<CF01_AMOUNT; log++) {

		strcpy(complete_key,KeyName);
		sprintf (log_str,"CF01_%d",log);
		strcat(complete_key,log_str);

		hndFileRead[log]=hndFileWrite[log]=INVALID_HANDLE_VALUE;

		if (RegOpenKey(HKEY_LOCAL_MACHINE,(const char *)complete_key,&new_key)!=ERROR_SUCCESS) {
			io_start=CARD_DEFAULT_ADR;
			io_length=CARD_DEFAULT_LEN;
		}
		else {
			DWORD type,len=sizeof(DWORD);
			if (RegQueryValueEx(new_key,"IOBase",0,&type,(LPBYTE)&io_start,&len)!=ERROR_SUCCESS) {
				io_start=CARD_DEFAULT_ADR;
			}
			len=sizeof(DWORD);
			if (RegQueryValueEx(new_key,"IOTaille",0,&type,(LPBYTE)&io_length,&len)!=ERROR_SUCCESS) {
				io_length=CARD_DEFAULT_LEN;
			}
			activ_slot=FALSE;
			for (slot=0; slot<CF01_SLOT_AMOUNT; slot++) {
				char slot_buffer[256];
				len=CARD_MAX_NAME;
				sprintf (slot_buffer,"Slot%c_Card",slot+'A');
				if (RegQueryValueEx(new_key,slot_buffer,0,&type,
						(LPBYTE)CF01Card[log].module_name[slot],&len)!=ERROR_SUCCESS) {
					strcpy(CF01Card[log].module_name[slot],VIDE);
				}
				if (stricmp (CF01Card[log].module_name[slot],VIDE)!=0) activ_slot=TRUE;
			}
			RegCloseKey(new_key);
		}
		CF01Card[log].io_start=io_start;
		CF01Card[log].io_length=io_length;

		if (!activ_slot) continue;

		strcpy(file_name,"\\\\.\\");		  
		strcat(file_name,log_str);
		hndFileRead[log]=CreateFile(file_name,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL);
		hndFileWrite[log]=CreateFile(file_name,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);

		if (hndFileRead[log]==INVALID_HANDLE_VALUE || hndFileWrite[log]==INVALID_HANDLE_VALUE) return 0;
		for (p=0; p<io_length; p++) {
			if (port_number_read[io_start+p]!=INVALID_HANDLE_VALUE) return 0;
			if (port_number_write[io_start+p]!=INVALID_HANDLE_VALUE) return 0;
			port_number_read[io_start+p]=hndFileRead[log];
			port_number_write[io_start+p]=hndFileWrite[log];
		}
	}
	
#endif
	return 1;
}
//+-----------------------------------------------------------------+
#else		// Point d'entre de la DLL pour Win31
//+-----------------------------------------------------------------+
int CALLBACK LibMain (HINSTANCE hInstance,WORD wDataSeg,WORD wHeapSize,LPSTR lpszCmdLine)
{
	if (wHeapSize > 0) UnlockData(0);
	return (1);
}
//+-----------------------------------------------------------------+
#endif

#ifdef WINNT 

int _CDECL_ CF01_GetModuleName(char *buffer,int card_no,int slot)
{
	strcpy(buffer,CF01Card[card_no].module_name[slot]);
	return (stricmp (buffer,VIDE)!=0);
}

int	_CDECL_ CF01_GetModuleStart(int card_no)
{
	return CF01Card[card_no].io_start;
}

int _CDECL_ CF01_GetModuleEnd(int card_no)
{
	return CF01Card[card_no].io_start+CF01Card[card_no].io_length-1;
}

int _CDECL_ CF01_IsModuleOk(int portid)
{
	return (port_number_read[portid]!=INVALID_HANDLE_VALUE && 
		port_number_write[portid]!=INVALID_HANDLE_VALUE);
}

#endif

/* +-----------------------------------------------------------------+
   | Function's Name   : WEP                                         |
   +-----------------------------------------------------------------+
   | Task              : fonction de "d-initialisation"             |
   |                     "Windows Exit Procedure"                    |
   |                     Lorsque WEP est appele par Windows,nParam  |
   |                     vaut soit WEP_FREE_DLL soit WEP_SYSTEM_EXIT |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    nParam :                             |
   |                                    WEP_FREE_DLL ou              |
   |                                    WEP_SYSTEM_EXIT              |
   +-----------------------------------------------------------------+
   | Return Value      : int                                         |
   +-----------------------------------------------------------------+*/

#ifndef WIN32
int _CDECL_ WEP (int nParam)
{
	return (1);
}
#endif

/********************************************************************/

/* +-----------------------------------------------------------------+
   | Function's Name   : CF01_Inportb                                     |
   +-----------------------------------------------------------------+
   | Task              : Lectute du port d'entre  sur 8 bits        |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    portid : adress de port              |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned char :                             |
   |                             la valeur de l'entre sur 8 bits    |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ CF01_Inportb(int portid)
{
#ifdef WIN32
	#ifdef WINNT
	  BOOL    IoctlResult;
		UCHAR   CharData;
		LONG    IoctlCode;
		ULONG   DataLength;
		ULONG   Port=portid;
	  DWORD   ReturnedLength;     // Number of bytes returned
		IoctlCode=IOCTL_SELIA_CARD_READ_PORT_UCHAR;
    DataLength=sizeof(CharData);

		if (port_number_read[portid]==INVALID_HANDLE_VALUE) return 0;
	  IoctlResult=DeviceIoControl(port_number_read[portid],  // Handle to device
                          IoctlCode,          // IO Control code for Read
                          &Port,			        // Buffer to driver.
                          sizeof(Port),				// Length of buffer in bytes.
                          &CharData,		      // Buffer from driver.
                          DataLength,         // Length of buffer in bytes.
                          &ReturnedLength,    // Bytes placed in DataBuffer.
                          NULL);              // NULL means wait till op. completes.
  
    return CharData;
	#else
		return (inp((unsigned short)portid));
	#endif
#else
  return (inportb(portid));
#endif
}

/* +-----------------------------------------------------------------+
   | Procedure's Name   : CF01_Outportb                                   |
   +-----------------------------------------------------------------+
   | Task               : Ecriture sur la sortie sur 8 bits          |
   +-----------------------------------------------------------------+
   | Input Parameters   :                                            |
   |                      int   portid : adresse de port             |
   |                      int   value  : Valeur  crire             |
   +-----------------------------------------------------------------+*/

void _CDECL_ CF01_Outportb(int portid, unsigned long value)
{
#ifdef WIN32
	#ifdef WINNT

		BOOL    IoctlResult;
	  SELIA_CARD_WRITE_INPUT InputBuffer;    // Input buffer for DeviceIoControl
	  LONG                IoctlCode;
	  ULONG               DataLength;
	  ULONG               ReturnedLength; // Number of bytes returned in output buffer


		if (port_number_write[portid]==INVALID_HANDLE_VALUE) return;
    IoctlCode = IOCTL_SELIA_CARD_WRITE_PORT_UCHAR;
	  InputBuffer.CharData = (UCHAR)value;
	  InputBuffer.PortNumber=portid;
    DataLength = offsetof(SELIA_CARD_WRITE_INPUT, CharData)+sizeof(InputBuffer.CharData);

		IoctlResult = DeviceIoControl(
                      port_number_write[portid],	// Handle to device
                      IoctlCode,              // IO Control code for Write
                      &InputBuffer,		          // Buffer to driver.  Holds port & data.
                      DataLength,             // Length of buffer in bytes.
                      NULL,                   // Buffer from driver.   Not used.
                      0,                      // Length of buffer in bytes.
                      &ReturnedLength,        // Bytes placed in outbuf.  Should be 0.
                      NULL);                  // NULL means wait till I/O completes.

	#else
		outp((unsigned short)portid,value);
	#endif
#else
	outportb (portid,value);
#endif
}

/********************************************************************/

/* +-----------------------------------------------------------------+
   | Function's Name   : MD01_ReadInput                              |
   +-----------------------------------------------------------------+
   | Task              : Lectute du port d'entre  sur 8 bits        |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int :                                       |
   |                 l'octet du poids faible = la valeur de l'entre |
   +-----------------------------------------------------------------+*/
int  _CDECL_ MD01_ReadInput(int AdrModule)
{
  return ((int)CF01_Inportb(AdrModule) & 0x00ff);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MD02_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : crire un octet sur la sortie               |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    Value      : valeur  crire         |
   +-----------------------------------------------------------------+*/
void _CDECL_ MD02_WriteOutput(int AdrModule, int Value)
{
	CF01_Outportb (AdrModule,(unsigned char)Value);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MD03_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : crire un octet sur la sortie TTL           |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    Value      : valeur  crire         |
   +-----------------------------------------------------------------+*/

void _CDECL_ MD03_WriteOutput(int AdrModule, int Value)
{
  CF01_Outportb (AdrModule,(unsigned char) Value);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MD03_ReadInput                              |
   +-----------------------------------------------------------------+
   | Task              : Lectute du port d'entre  sur 8 bits TTL    |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int  :                                      |
   |                   l'octet du poids faible = valeur de l'entre  |
   +-----------------------------------------------------------------+*/
int _CDECL_ MD03_ReadInput(int AdrModule)
{
	return ((int)(CF01_Inportb (AdrModule)) & 0x00ff);
}


/* +-----------------------------------------------------------------+
   | Function's Name   : MD04_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : ecrire une valeur sur le port de sortie PNP |
   |                             0x00 <= valeur <= 0x3f              |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   /                     int    Value     : valeur  crire          /
   +-----------------------------------------------------------------+
   | Return Value      :                                             |
   +-----------------------------------------------------------------+*/
void _CDECL_ MD04_WriteOutput (int AdrModule, int Value)
{
  CF01_Outportb(AdrModule,(unsigned char)Value);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MD05_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : ecrire une valeur sur le port de sortie NPN |
   |                             0x00 <= valeur <= 0x3f              |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int :                                       |
   |                   l'octet du poids faible= valeur de la sortie  |
   +-----------------------------------------------------------------+
   | Return Value      :                                             |
   +-----------------------------------------------------------------+*/
void _CDECL_ MD05_WriteOutput(int AdrModule, int Value)
{
  MD04_WriteOutput (AdrModule,Value);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MD06_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : crire deux octets sur la sortie PNP        |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    Value      : valeur  crire         |
   +-----------------------------------------------------------------+*/
void _CDECL_ MD06_WriteOutput(int AdrModule, unsigned int Value)
{
  CF01_Outportb (AdrModule,(unsigned char)Value);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MD07_WriteOutput                            |
   +-----------------------------------------------------------------+
   | Task              : crire deux octets sur la sortie NPN        |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    Value      : valeur  crire         |
   +-----------------------------------------------------------------+*/
void _CDECL_ MD07_WriteOutput(int AdrModule, unsigned int Value)
{
  CF01_Outportb (AdrModule,(unsigned char)Value);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MA01_ReadAnalogueIn                         |
   +-----------------------------------------------------------------+
   | Task              : Lectute d'un canal analogique               |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   |                     int    Channel   : numro du canal          |
   |                     long   TimeOut   : timeout                  |
   +-----------------------------------------------------------------+
   | Return Value      : int              :                          |
   |                                        -1 si canal faux         |
   |                                        -2 si dpassement Timeout|
   |                                        valeur lue sinon         |
   |                                                                 |
   +-----------------------------------------------------------------+*/
int _CDECL_ MA01_ReadAnalogueIn(int AdrModule, int Channel, unsigned long TimeOut)
{
  if (Channel < 1 || Channel > 8) return (-1) ;

  CF01_Outportb (AdrModule,(unsigned char)(Channel - 1));         /* Choix du canal            */
  CF01_Outportb (AdrModule,(unsigned char)(Channel - 1));         /* Choix du canal            */
  CF01_Outportb (AdrModule + 1, 0);                 /* lancement de la conversion         */
  do
    TimeOut--;
  while (TimeOut > 0 && (CF01_Inportb (AdrModule + 1) & 1) == 1);

  if (TimeOut <= 0) return ( -2 ) ;

  return (( ((int)CF01_Inportb (AdrModule) << 4) | (CF01_Inportb (AdrModule + 1) >> 4) ));
}

/*+-----------------------------------------------------------------+
	| Fonction's Name   : MA02_WriteAnalogueOut                       |
	+-----------------------------------------------------------------+
	| Task              : Ecrire une valeur analogique sur 1 canal    |
	+-----------------------------------------------------------------+
	| Input Parameters  :                                             |
	|                     int    AdrModule : adress de module         |
	|                     int    Channel   : numro du canal          |
	|                     int    Value     : valeur binaire  crire  |
	+-----------------------------------------------------------------+
	| Return Value      : int            :                            |
	+-----------------------------------------------------------------+*/

void _CDECL_ MA02_WriteAnalogueOut (int AdrModule, int Channel,int Value)
{
  CF01_Outportb (AdrModule,(unsigned char)(((Channel-1) << 1 ) + 1));
	CF01_Outportb (AdrModule + 1,(unsigned char)(Value >> 8));
	CF01_Outportb (AdrModule,(unsigned char)((Channel-1) << 1));
	CF01_Outportb (AdrModule + 1, (unsigned char)(Value & 0xFF) );
}

/*+-----------------------------------------------------------------+
	| Fonction's Name   : MA04_WriteAnalogueOut                       |
	+-----------------------------------------------------------------+
	| Task              : Ecrire une valeur analogique sur 1 canal    |
	+-----------------------------------------------------------------+
	| Input Parameters  :                                             |
	|                     int    AdrModule : adress de module         |
	|                     int    Channel   : numro du canal          |
	|                     int    Value     : valeur binaire  crire  |
	+-----------------------------------------------------------------+
	| Return Value      : int            :                            |
	+-----------------------------------------------------------------+*/

void _CDECL_ MA04_WriteAnalogueOut (int AdrModule, int Channel,int Value)
{
	CF01_Outportb (AdrModule,(unsigned char)(((Channel-1) << 1 ) + 1));
	CF01_Outportb (AdrModule + 1,(unsigned char)(Value >> 8));
	CF01_Outportb (AdrModule,(unsigned char)((Channel-1) << 1));
	CF01_Outportb (AdrModule + 1,(unsigned char)(Value & 0xFF) );
}

/********************************************************************/

/*+-----------------------------------------------------------------+
	| Function's Name   : MA03_ReadAnalogueIn                         |
	+-----------------------------------------------------------------+
	| Task              : Lectute d'un canal analogique               |
	+-----------------------------------------------------------------+
	| Input Parameters  :                                             |
	|                     int    AdrModule : adress de module         |
	|                     int    Channel   : numro du canal          |
	|                     long   TimeOut   : timeout                  |
	+-----------------------------------------------------------------+
	| Return Value      : int              :                          |
	|                                        -1 si canal faux         |
	|                                        -2 si dpassement Timeout|
	|                                        valeur lue sinon         |
	|                                                                 |
	+-----------------------------------------------------------------+*/

int _CDECL_ MA03_ReadAnalogueIn(int AdrModule, int Channel,unsigned long TimeOut)
{
  if (Channel < 1 || Channel > 32) return ( -1 ) ;

	CF01_Outportb (AdrModule,(unsigned char)(Channel - 1));   /* Choix du canal            */

	do
		TimeOut--;
	while (TimeOut > 0 && (CF01_Inportb (AdrModule + 1) & 1) == 1);

	if (TimeOut <= 0) return ( -2 ) ;

	return( ((int)CF01_Inportb (AdrModule) << 4) | (CF01_Inportb (AdrModule + 1) >> 4 ) );
}

/********************************************************************/

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC02_ClearCounter                           |
   +-----------------------------------------------------------------+
   | Task              : Initialisation du compteur                  |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+*/

void  _CDECL_ MC02_ClearCounter (int AdrModule)
{
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, 0);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC02_ReadCounter                            |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long    :                          |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC02_ReadCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name   : MC02_PresetCounter                         |
   +-----------------------------------------------------------------+
   | Task               : Inscrire une valeur dans le compteur       |
   +-----------------------------------------------------------------+
   | Input Parameters   :                                            |
   |                      int   AdrModule : adress de module         |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC02_PresetCounter (int AdrModule, unsigned long Preset)
{
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 16L));
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 8L));
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset));
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC02_ReadLatchCounter                       |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : long           :                            |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC02_ReadLatchCounter (int AdrModule)
{
	unsigned long Counter;
	CF01_Outportb (AdrModule, 4);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 5);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 6);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC02_IsLineExtern                           |
   +-----------------------------------------------------------------+
   | Task              : Retourne l'tat de la ligne extrieure      |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int            :                            |
   |                                        0 si non active          |
   |                                        1 si active              |
   +-----------------------------------------------------------------+*/

int _CDECL_ MC02_IsLineExtern (int AdrModule)
{
	if ((CF01_Inportb (AdrModule) & 1) == 0) return 1;
	return 0;
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC02_IsLineFault                            |
   +-----------------------------------------------------------------+
   | Task              : Retourne l'tat de la ligne extrieure      |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
+   | Return Value      : int            :                            |
   |                                        0 si non active          |
   |                                        1 si active              |
   +-----------------------------------------------------------------+*/

int _CDECL_ MC02_IsLineFault (int AdrModule)
{
	if ((CF01_Inportb (AdrModule) & 2) == 0) return 1;
	else return 0;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC03_ClearCounter                           |
   +-----------------------------------------------------------------+
   | Task              : Initialisation du compteur                  |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC03_ClearCounter (int AdrModule)
{
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, 0);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC03_ReadCounter                            |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long    :                          |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC03_ReadCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name   : MC03_PresetCounter                         |
   +-----------------------------------------------------------------+
   | Task               : Inscrire une valeur dans le compteur       |
   +-----------------------------------------------------------------+
   | Input Parameters   :                                            |
   |                      int   AdrModule : adress de module         |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC03_PresetCounter (int AdrModule, unsigned long Preset)
{
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 16L));
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 8L));
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset));
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC03_ReadLatchCounter                       |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : long           :                            |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC03_ReadLatchCounter (int AdrModule)
{
	unsigned long Counter;
	CF01_Outportb (AdrModule, 4);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 5);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 6);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	return Counter;
}

/********************************************************************/

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC04_ClearCounter                           |
   +-----------------------------------------------------------------+
   | Task              : Initialisation du compteur 32 bits          |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adresse du module        |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC04_ClearCounter (int AdrModule)
{
	CF01_Outportb (AdrModule, 3);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, 0);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC04_ReadCounter                            |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur (valeur instantane)    |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adresse du module        |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long    :                          |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC04_ReadCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);         /* slction registre LSB + Latch interne */
	/* latch 2 fois car la 1re valeur est rrone */
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);         /* lecture LSB */
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;  /* slction registre MID Low */
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L; /* slction registre MID High */
	CF01_Outportb (AdrModule, 3);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 24L; /* slction registre MSB */
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name   : MC04_PresetCounter                         |
   +-----------------------------------------------------------------+
   | Task               : Inscrire une valeur dans le compteur       |
   +-----------------------------------------------------------------+
   | Input Parameters   :                                            |
   |                      int   AdrModule : adresse du module        |
   |                      unsigned long Preset:new valeur du compteur|
   |----------------------------------------------------------------+*/

void _CDECL_ MC04_PresetCounter (int AdrModule,unsigned long Preset)
{
	CF01_Outportb (AdrModule, 3);           /* Slection MSB */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 24L));
	CF01_Outportb (AdrModule, 2);           /* Slection MIDLOW */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 16L));
	CF01_Outportb (AdrModule, 1);             /* Slection MIDHIGH */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 8L));
	CF01_Outportb (AdrModule, 0);               /* Slection LSB */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset));
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC04_ReadLatchCounter                       |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long : valeur du compteur          |
   |                                                                 |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC04_ReadLatchCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	CF01_Outportb (AdrModule, 3);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 24L;
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC04_IsLineExtern                           |
   +-----------------------------------------------------------------+
   | Task              : Retourne l'tat de la ligne extrieure      |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int            :                            |
   |                                        0 si non active          |
   |                                        1 si active              |
   +-----------------------------------------------------------------+*/

int _CDECL_ MC04_IsLineExtern (int AdrModule)
{
	if ((CF01_Inportb (AdrModule) & 1) == 0) return 1;             /* entre extrieure active */
	else return 0;
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC04_IsLineFault                            |
   +-----------------------------------------------------------------+
   | Task              : Retourne une rupture de ligne               |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : int  :   0 si pas de rupture de ligne       |
   |                              1 si rupture de ligne              |
   +-----------------------------------------------------------------+*/

int _CDECL_ MC04_IsLineFault (int AdrModule)
{
	if ((CF01_Inportb (AdrModule) & 2) == 0) return 1;
	return 0;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC05_ClearCounter                           |
   +-----------------------------------------------------------------+
   | Task              : Initialisation du compteur 32 bits          |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adresse du module        |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC05_ClearCounter (int AdrModule)
{
	CF01_Outportb (AdrModule, 3);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 2);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 1);
	CF01_Outportb (AdrModule + 1, 0);
	CF01_Outportb (AdrModule, 0);
	CF01_Outportb (AdrModule + 1, 0);
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC05_ReadCounter                            |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur (valeur instantane)    |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adresse du module        |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long    :                          |
   |                                        valeur du compteur       |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC05_ReadCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);         /* slction registre LSB + Latch interne */
	/* latcher 2 fois car la 1re valeur est rrone */
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);         /* lecture LSB */
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;  /* slction registre MID Low */
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L; /* slction registre MID High */
	CF01_Outportb (AdrModule, 3);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 24L; /* slction registre MSB */
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Procedure's Name   : MC05_PresetCounter                         |
   +-----------------------------------------------------------------+
   | Task               : Inscrire une valeur dans le compteur       |
   +-----------------------------------------------------------------+
   | Input Parameters   :                                            |
   |                      int   AdrModule : adresse du module        |
   |                      unsigned long Preset:new valeur du compteur|
   |----------------------------------------------------------------+*/

void _CDECL_ MC05_PresetCounter (int AdrModule,unsigned long Preset)
{
	CF01_Outportb (AdrModule, 3);           /* Slection MSB */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 24L));
	CF01_Outportb (AdrModule, 2);           /* Slection MIDLOW */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 16L));
	CF01_Outportb (AdrModule, 1);             /* Slection MIDHIGH */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset >> 8L));
	CF01_Outportb (AdrModule, 0);               /* Slection LSB */
	CF01_Outportb (AdrModule + 1, (unsigned char)(Preset));
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC05_ReadLatchCounter                       |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur                         |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long : valeur du compteur          |
   |                                                                 |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC05_ReadLatchCounter (int AdrModule)
{
	unsigned long Counter;

	CF01_Outportb (AdrModule, 0);
	Counter = (unsigned long)CF01_Inportb (AdrModule + 1);
	CF01_Outportb (AdrModule, 1);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 8L;
	CF01_Outportb (AdrModule, 2);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 16L;
	CF01_Outportb (AdrModule, 3);
	Counter |= (unsigned long)CF01_Inportb (AdrModule + 1) << 24L;
	return Counter;
}

/* +-----------------------------------------------------------------+
   | Function's Name   : MC01_ReadCounter                            |
   +-----------------------------------------------------------------+
   | Task              : Lecture du compteur SSI                     |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule : adress de module         |
   +-----------------------------------------------------------------+
   | Return Value      : unsigned long : valeur du compteur          |
   |                                                                 |
   +-----------------------------------------------------------------+*/

unsigned long _CDECL_ MC01_ReadCounter (int AdrModule)
{
	long Valeur = 0L;
	unsigned long  lsb,msb,midb,parite;



	CF01_Outportb (AdrModule, 0x55);
	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);



    

	
	while ((CF01_Inportb (AdrModule + 1) & 0x02) == 0x02);
	parite = (unsigned long)CF01_Inportb (AdrModule);
	



    while ((CF01_Inportb (AdrModule + 1) & 0x02) == 0x02);
	lsb = (unsigned long)CF01_Inportb (AdrModule);
	lsb = lsb&0xFF;


	while ((CF01_Inportb (AdrModule + 1) & 0x02) == 0x02);
	midb = (unsigned long)CF01_Inportb (AdrModule);
	midb = midb&0xFF;



	while ((CF01_Inportb (AdrModule + 1) & 0x02) == 0x02);
	msb = (unsigned long)CF01_Inportb (AdrModule);
	msb = msb&0xFF;


	Valeur = (msb <<16) + (midb<<8) + (lsb)   ;
	return (Valeur);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC01_Mode                                   |
   +-----------------------------------------------------------------+
   | Task              : crire un octet de mode sur le module SSI   |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    Value      : valeur  crire         |
   +-----------------------------------------------------------------+*/

void _CDECL_ MC01_Mode(int AdrModule, int Value)
{
//	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	CF01_Outportb (AdrModule,(unsigned char)Value);
//	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
}

/* +-----------------------------------------------------------------+
   | Procedure's Name  : MC01me_ExtMode                              |
   +-----------------------------------------------------------------+
   | Task              : Configure module Maitre/Esclave             |
   +-----------------------------------------------------------------+
   | Input Parameters  :                                             |
   |                     int    AdrModule  : adress de module        |
   |                     int    frequency    0->250 kHz 1->125 kHz   |
   |                     int    length       longueur trame 13 ou 25 |
   |                     int    code         0->Gray 1->Binaire      |
   |                     int    master       0->Matre 1->Esclave    |
   |                     int    frequency    0->Stop 1->Start        |
   +-----------------------------------------------------------------+*/


void _CDECL_ MC01me_ExtMode(int AdrModule, int frequency, int length, int code, int master, int start)
{
	MC01_Mode ( AdrModule,0x80);//entree dans le mode de programmation
	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	
	if(frequency==0)
	{
		MC01_Mode ( AdrModule,0x81);//250 kHz
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}
	else
	{
		MC01_Mode ( AdrModule,0x82);//125 kHz
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}

	
	MC01_Mode ( AdrModule,0x83);//nombre de bits
	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	CF01_Outportb(AdrModule,length);
	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);

	if(code==0)
	{
		MC01_Mode ( AdrModule,0x84);//code gray
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}
	else
	{
		MC01_Mode ( AdrModule,0x85);//code binaire
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}

	if(master==0)
	{
		MC01_Mode ( AdrModule,0x88);//maitre
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}
	else
	{
		MC01_Mode ( AdrModule,0x89);//esclave
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}

	if(start==0)
	{
		MC01_Mode ( AdrModule,0x87);//arret codeur
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}
	else
	{
		MC01_Mode ( AdrModule,0x86);//deverrouillage codeur
		while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);
	}

    MC01_Mode ( AdrModule,0xA0);
	while ((CF01_Inportb (AdrModule + 1) & 0x04) == 0x00);

}

/********************************************************************/
/*                        THE END                                   */
/********************************************************************/


