DECLARE FUNCTION MA01AnalogIn! (AdrModule AS INTEGER, Channel AS INTEGER)
DECLARE FUNCTION MA01Bin2Real! (BinValue AS INTEGER, Mini AS SINGLE, Maxi AS SINGLE)

'  Ŀ
'   (C) SELIA design    .                                                 
'  Ĵ
'   Tel :  (00 33) 88 86 68 54                                            
'   Fax :  (00 33) 88 86 74 76                                            
'  Ĵ
'   Project     : CF01                 Compiler   : QBASIC               
'   Module name : MA01.BAS             Version    : 1.1                  
'  Ĵ
'   Author    : Francis GLOHR          Date       : 17 March 1994        
'  Ĵ
'   Descript. :                                                           
'                Function to use the CF01 with MA01 modules               
'  Ĵ
'                               UPDATES                                   
'  Ĵ
'     Date      Author            Description of updates                
'  Ĵ
'  17/03/94  F. Glohr    Creation V 1.00                                
'  --------- -----------------------------------------------------------
'  

'  Ŀ
'   Const definition                                                      
'  

' Base adress of the CF01 board is Hex 300 = Dec 768
' ****************************************************}

CONST AdrModule = &H300                         ' Module is at position "A"
                                                ' onto the CF01


' -------------------------------------------------------------------------
'  Note: For over module position you must correct the constant ADRMODULE
'        with the correct module adresse as specified in the CF01 handbook
' -------------------------------------------------------------------------



'  Ŀ
'   Name :  main                                                          
'  Ĵ
'   Description :                                                         
'     Example to use the MA01 module                                      
'  Ĵ
'   Input :                                                               
'  Ĵ
'   Output:                                                               
'  }
   CLS
   LOCATE 1, 10: PRINT ("Example for use the MA01 module with the CF01 board")
   LOCATE 2, 10: PRINT ("-----------------------------------------------------")

   LOCATE 4, 10: PRINT ("Press a key to quit program")

   LOCATE 6, 5: PRINT ("Ŀ")
   LOCATE 7, 5: PRINT (" Channel  Bin value  Voltage     %   ")
   LOCATE 8, 5: PRINT ("Ĵ")

   FOR k% = 0 TO 8
      LOCATE 9 + k%, 5: PRINT "   "; k%; "                               "
   NEXT
   LOCATE 17, 5:    PRINT ("")

   DO
      FOR k% = 1 TO 8
         Bin% = MA01AnalogIn(AdrModule, k%)
         LOCATE 8 + k%, 19: PRINT USING "####"; Bin%
         Volt = MA01Bin2Real(Bin%, 0!, 10!)
         LOCATE 8 + k%, 28: PRINT USING "+##.####"; Volt
         Volt = MA01Bin2Real(Bin%, 0!, 100!)
         LOCATE 8 + k%, 40: PRINT USING "###"; Volt
      NEXT
   LOOP UNTIL INKEY$ <> ""
END

'  Ŀ
'   Name :  MA01ReadInputBit                                              
'  Ĵ
'   Description :                                                         
'     Read analogue input value                                           
'  Ĵ
'   Input :  AdrModule : INTEGER: Adress of the MA01 module (see Note)    
'            Bit       : INTEGER: Channel number (1..8)                   
'  Ĵ
'   Output:  INTEGER : result from the reading of MA01                    
'  
FUNCTION MA01AnalogIn (AdrModule AS INTEGER, Channel AS INTEGER)
   OUT AdrModule, Channel - 1           ' Channel select
   FOR Delay = 0 TO 10: NEXT Delay
   OUT AdrModule + 1, 0                 ' Start conversion

   DO
   LOOP UNTIL (INP(AdrModule + 1) AND 1) <> 1

   MA01AnalogIn = (INP(AdrModule) * 16) + (INP(AdrModule + 1) / 16)
END FUNCTION

'  Ŀ
'   Name :  MA01Bin2Real                                                  
'  Ĵ
'   Description :                                                         
'     Convert Bunary to Real value                                        
'  Ĵ
'   Input :  AdrModule : INTEGER: Adress of the MA01 module (see Note)    
'  Ĵ
'   Output:  INTEGER : Converting value                                   
'  
FUNCTION MA01Bin2Real (BinValue AS INTEGER, Mini AS SINGLE, Maxi AS SINGLE)
   alsb = ABS(Mini - Maxi) / 4096!
   MA01Bin2Real = (BinValue * alsb) + Mini
END FUNCTION

