DECLARE SUB MA02AnalogOut (AdrModule AS INTEGER, Channel AS INTEGER, Bin AS INTEGER)
'  Ŀ
'   (C) SELIA design                                                      
'  Ĵ
'   Tel :  (00 33) 88 86 68 54                                            
'   Fax :  (00 33) 88 86 74 76                                            
'  Ĵ
'   Project     : CF01                 Compiler   : QBASIC               
'   Module name : MA02.BAS             Version    : 1.1                  
'  Ĵ
'   Author    : Francis GLOHR          Date       : 17 March 1994        
'  Ĵ
'   Descript. :                                                           
'                Function to use the CF01 with MA02 modules               
'  Ĵ
'                               UPDATES                                   
'  Ĵ
'     Date      Author            Description of updates                
'  Ĵ
'  17/03/94  F. Glohr    Creation V 1.00                                
'  --------- -----------------------------------------------------------
'  

'  Ŀ
'   Const definition                                                      
'  

' Base adress of the CF01 board is Hex 300 = Dec 768
' ****************************************************

CONST SizeTab = 100
CONST AdrModule = &H300                         ' Module is at position "A"
                                                ' onto the CF01


' -------------------------------------------------------------------------
' Note: For over module position you must correct the constant ADRMODULE
'       with the correct module adresse as specified in the CF01 handbook
' -------------------------------------------------------------------------

'  Ŀ
'   Name :  main                                                          
'  Ĵ
'   Description :                                                         
'     Example to use the MA02 module                                      
'  Ĵ
'   Input :                                                               
'  Ĵ
'   Output:                                                               
'  }
DIM SHARED t(SizeTab + 1) AS INTEGER

CLS
LOCATE 1, 10: PRINT (" Example for use the MA02 module with the CF01 board")
LOCATE 2, 10: PRINT (" -----------------------------------------------------")

LOCATE 4, 10: PRINT (" Press a key to quit program")

LOCATE 6, 5: PRINT (" Generating A sin(wt) : A = 10v")
LOCATE 7, 5: PRINT (" Calculating the curve")

FOR k = 1 TO SizeTab + 1
   Sin1 = 10 * SIN(2 * 3.14 * ((k - 1) / SizeTab))
   t(k) = FIX((Sin1) / (20 / 4095)) + 2047
NEXT k
LOCATE 7, 5: PRINT ("see the curve on channel N: 0")

k = 1
DO
  IF (k >= SizeTab + 1) THEN k = 1
  MA02AnalogOut AdrModule, 0, t(k)
  k = k + 1
LOOP UNTIL INKEY$ <> ""
MA02AnalogOut AdrModule, 0, 0
END

'  Ŀ
'   Name :  MA02WriteAnalog                                               
'  Ĵ
'   Description :                                                         
'     Read analogue input value                                           
'  Ĵ
'   Input :  AdrModule : INTEGER: Adress of the MA02 module (see Note)    
'            Bit       : INTEGER: Channel number (1..4)                   
'  Ĵ
'   Output:                                                               
'  }
SUB MA02AnalogOut (AdrModule AS INTEGER, Channel AS INTEGER, Bin AS INTEGER)
   OUT AdrModule, (2 * Channel) + 1
   OUT AdrModule + 1, (Bin / 256)
   OUT AdrModule, (2 * Channel)
   OUT AdrModule + 1, Bin
END SUB

