{  Ŀ
    (C) SELIA design                                                      
   Ĵ
    Tel :  (00 33) 88 86 68 54                                            
    Fax :  (00 33) 88 86 74 76                                            
   Ĵ
    Project     : CF01                 Compiler   : TURBO PASCAL         
    Module name : MA02.PAS             Version    : 6.00                 
   Ĵ
    Author    : Francis GLOHR          Date       : 17 March 1994        
   Ĵ
    Descript. :                                                           
                 Function to use the CF01 with MA02 modules               
   Ĵ
                                UPDATES                                   
   Ĵ
      Date      Author            Description of updates                
   Ĵ
   17/03/94  F. Glohr    Creation V 1.00                                
   --------- -----------------------------------------------------------
   }
program MA02;

uses Dos, Crt;

{  Ŀ
    Const definition                                                      
   }

{ Base adress of the CF01 board is Hex 300 = Dec 768
  ****************************************************}

CONST
      SizeTab   = 512;
      AdrModule = $300;                         { Module is at position "A"     }
                                                { onto the CF01                 }


{ -------------------------------------------------------------------------
  Note: For over module position you must correct the constant ADRMODULE
        with the correct module adresse as specified in the CF01 handbook
  -------------------------------------------------------------------------}


{  Ŀ
    Name :  MA02WriteAnalog                                               
   Ĵ
    Description :                                                         
      Read analogue input value                                           
   Ĵ
    Input :  AdrModule : INTEGER: Adress of the MA02 module (see Note)    
             Bit       : INTEGER: Channel number (1..4)                   
   Ĵ
    Output:                                                               
   }
procedure MA02AnalogOut  (AdrModule : INTEGER; Channel : INTEGER; Bin : INTEGER);
Begin
   Port [AdrModule] := (Channel shl 1) + 1;
   Port [AdrModule + 1] := (Bin shr 8);
   Port [AdrModule] := (Channel shl 1);
   Port [AdrModule + 1] := Bin;
End;

{  Ŀ
    Name :  main                                                          
   Ĵ
    Description :                                                         
      Example to use the MA02 module                                      
   Ĵ
    Input :                                                               
   Ĵ
    Output:                                                               
   }
Var
   k   : Integer;
   Tab : Array [0..SizeTab] of integer;
   Sin1: Real;

Begin

   ClrScr;
   GoToXY (10, 1); Write ('Example for use the MA02 module with the CF01 board');
   GoToXY (10, 2); Write ('-----------------------------------------------------');

   GoToXY (10, 4); Write ('Press a key to quit program');

   GoToXY (5, 6); Write ('Generating A sin(wt) : A = 10v');
   GoToXY (5, 7); Writeln ('Calculating the curve');

   For k := 0 To SizeTab Do Begin
      Sin1   := 10 * sin (2 * 3.14 * ( k / SizeTab) );
      Tab[k] := Round((Sin1) / (20/4095)) + 2047;
   End;
   GoToXY (5, 7); Writeln ('see the curve on channel N: 0');

   k := -1;
   Repeat
     inc (k);
     if (k >= SizeTab) Then k := 0;
     MA02AnalogOut (AdrModule, 0, Tab[k]);
   Until KeyPressed;
   MA02AnalogOut (AdrModule, 0, 2047);
End.
