{  +-----------------------------------------------------------------------+
    (C) SELIA design                                                      
   +-----------------------------------------------------------------------
    Tel :  (00 33) 88 86 68 54                                            
    Fax :  (00 33) 88 86 74 76                                            
   +-----------------------------------------------------------------------
    Project     : CF01                 Compiler   : TURBO PASCAL         
    Module name : MD01.PAS             Version    : 6.00                 
   +-------------------------------+---------------------------------------
    Author    : Francis GLOHR          Date       : 17 March 1994        
   +-----------------------------------------------------------------------
    Descript. :                                                           
                 Function to use the CF01 with MD01 modules               
   +-----------------------------------------------------------------------
                                UPDATES                                   
   +-----------------------------------------------------------------------
      Date      Author            Description of updates                
   +----------+-----------+------------------------------------------------
   17/03/94  F. Glohr    Creation V 1.00                                
   --------- -----------------------------------------------------------
   +-----------------------------------------------------------------------+}
program MD01;

uses Dos, Crt;

{  +-----------------------------------------------------------------------+
    Const definition                                                      
   +-----------------------------------------------------------------------+}

{ Base adress of the CF01 board is Hex 300 = Dec 768
  ****************************************************}

CONST
      AdrModule = $300;                         { Module is at position "A"     }
                                                { onto the CF01                 }


{ -------------------------------------------------------------------------
  Note: For over module position you must correct the constant ADRMODULE
        with the correct module adresse as specified in the CF01 handbook
  -------------------------------------------------------------------------}





{  +-----------------------------------------------------------------------+
    Name :  MD01ReadInputBit                                              
   +-----------------------------------------------------------------------
    Description :                                                         
      Read 1 bit digital input                                            
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD01 module (see Note)    
             Bit       : INTEGER: Position of the input to read (1..8)    
   +-----------------------------------------------------------------------
    Output:  INTEGER : result from the reading of MD01                    
   +-----------------------------------------------------------------------+}
Function MD01ReadBit (AdrModule : INTEGER; Bit : INTEGER):INTEGER;
Begin
   If (Port[AdrModule] AND (1 Shl (Bit-1)) <> 0) Then
      MD01ReadBit := 1
   Else
      MD01ReadBit := 0;
End;

{  +-----------------------------------------------------------------------+
    Name :  MD01ReadInput                                                 
   +-----------------------------------------------------------------------
    Description :                                                         
      Read 8 bit digital input                                            
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD01 module (see Note)    
   +-----------------------------------------------------------------------
    Output:  INTEGER : result from the reading of MD01                    
   +-----------------------------------------------------------------------+}
Function MD01ReadInput (AdrModule : INTEGER):INTEGER;
Begin
   MD01ReadInput := PORT[AdrModule];
End;

{  +-----------------------------------------------------------------------+
    Name :  main                                                          
   +-----------------------------------------------------------------------
    Description :                                                         
      Example to use the MD01 module                                      
   +-----------------------------------------------------------------------
    Input :                                                               
   +-----------------------------------------------------------------------
    Output:                                                               
   +-----------------------------------------------------------------------+}
Var
   k : Integer;

Begin

   ClrScr;
   GoToXY (10, 10); Write ('Example for use the MD01 module with the CF01 board');
   GoToXY (10, 11); Write ('-----------------------------------------------------');

   GoToXY (10, 25); Write ('Press a key to quit program');

   GoToXY (5, 14); Write ('+MSB-------------------------LSB+');
   GoToXY (5, 15); Write ('+-------------------------------+');
   GoToXY (5, 16); Write (' X  X  X  X  X  X  X  X ');
   GoToXY (5, 17); Write ('+-------------------------------+');

   GoToXY (10, 20); Write ('Digital input value (HEX): ');

   Repeat
      GoToXY (37, 20); Write (' ', MD01ReadInput (AdrModule), '    ');
      For k := 1 To 8 Do Begin
         GoToXY (3 + ((9 - k) * 4), 16);
         If MD01ReadBit(AdrModule, k) = 1 Then Write ('1')
         Else Write ('0');
      End;
   Until KeyPressed;
End.
