DECLARE SUB MD03ResetBit (AdrModule AS INTEGER, Bit AS INTEGER)
DECLARE SUB MD03SetBit (AdrModule AS INTEGER, Bit AS INTEGER)
DECLARE SUB MD03WriteOutput (AdrModule AS INTEGER, Relais AS INTEGER)
DECLARE FUNCTION MD03ReadInput! (AdrModule AS INTEGER)
'  +-----------------------------------------------------------------------+
'   (C) SELIA design                                                      
'  +-----------------------------------------------------------------------
'   Tel :  (00 33) 88 86 68 54                                            
'   Fax :  (00 33) 88 86 74 76                                            
'  +-----------------------------------------------------------------------
'   Project     : CF01                 Compiler   : QBASIC               
'   Module name : MD03.PAS             Version    : 1.1                  
'  +-------------------------------+---------------------------------------
'   Author    : Francis GLOHR          Date       : 17 March 1994        
'  +-----------------------------------------------------------------------
'   Descript. :                                                           
'                Function to use the CF01 with MD03 modules               
'  +-----------------------------------------------------------------------
'                               UPDATES                                   
'  +-----------------------------------------------------------------------
'     Date      Author            Description of updates                
'  +----------+-----------+------------------------------------------------
'  17/03/94  F. Glohr    Creation V 1.00                                
'  --------- -----------------------------------------------------------
'  +-----------------------------------------------------------------------+

'  +-----------------------------------------------------------------------+
'   Const definition                                                      
'  +-----------------------------------------------------------------------+

' Base adress of the CF01 board is Hex 300 = Dec 768
' ***************************************************

CONST AdrModule = &H300                        ' Module is at position "A"  
                                               ' onto the CF01              


' -------------------------------------------------------------------------
' Note: For over module position you must correct the constant ADRMODULE
'       with the correct module adresse as specified in the CF01 handbook
'       All output are active low !!!
'  -------------------------------------------------------------------------


'  +-----------------------------------------------------------------------+
'   Name :  main                                                          
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Example to use the MD01 module                                      
'  +-----------------------------------------------------------------------
'   Input :                                                               
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
   CLS
   LOCATE 10, 10: PRINT ("Example for use the MD03 module with the CF01 board")
   LOCATE 11, 10: PRINT ("-----------------------------------------------------")

   LOCATE 25, 10: PRINT ("Press a key to quit program")

   LOCATE 14, 5: PRINT ("+MSB-------------------------LSB+");
   LOCATE 15, 5: PRINT ("+-------------------------------+");
   LOCATE 16, 5: PRINT (" X  X  X  X  X  X  X  X ");
   LOCATE 17, 5: PRINT ("+-------------------------------+");


   MD03WriteOutput AdrModule, 0

   DO
      FOR i% = 1 TO 8
         MD03SetBit AdrModule, i%
         l = MD03ReadInput(AdrModule)
         FOR k = 1 TO 8
            LOCATE 16, 3 + ((9 - k) * 4)
            IF (l AND (2 ^ (k - 1))) <> 0 THEN
               PRINT "1"
            ELSE
               PRINT "0"
            END IF
         NEXT k

         FOR k = 1 TO 100: NEXT k
         MD03ResetBit AdrModule, i%
      NEXT
   LOOP UNTIL INKEY$ <> ""
END

'  +-----------------------------------------------------------------------+
'   Name :  MD03ReadOutputStatus                                          
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Read current output value                                           
'  +-----------------------------------------------------------------------
'   Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
'  +-----------------------------------------------------------------------
'   Output:  INTEGER   : Relais status                                    
'  +-----------------------------------------------------------------------+}
FUNCTION MD03ReadInput (AdrModule AS INTEGER)
   MD03ReadInput = INP(AdrModule)
END FUNCTION

'  +-----------------------------------------------------------------------+
'   Name :  MD03ResetBit                                                  
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Reset 1 bit digital output                                          
'  +-----------------------------------------------------------------------
'   Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
'            Bit       : INTEGER: Position of the output to write(1..8)   
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
SUB MD03ResetBit (AdrModule AS INTEGER, Bit AS INTEGER)
   OUT AdrModule, (INP(AdrModule) AND NOT (2 ^ (Bit - 1)))
END SUB

'  +-----------------------------------------------------------------------+
'   Name :  MD03SetBit                                                    
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Set 1 bit digital output                                            
'  +-----------------------------------------------------------------------
'   Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
'            Bit       : INTEGER: Position of the output to Write(1..8)   
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
SUB MD03SetBit (AdrModule AS INTEGER, Bit AS INTEGER)
   OUT AdrModule, INP(AdrModule) OR (2 ^ (Bit - 1))
END SUB

'  +-----------------------------------------------------------------------+
'   Name :  MD03PRINTOutput                                               
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Write 8 bit digital output                                          
'  +-----------------------------------------------------------------------
'   Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
'            Relais    : INTEGER: Value to write onto MD03                
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
SUB MD03WriteOutput (AdrModule AS INTEGER, Relais AS INTEGER)
   OUT AdrModule, Relais
END SUB

