{  +-----------------------------------------------------------------------+
    (C) SELIA design                                                      
   +-----------------------------------------------------------------------
    Tel :  (00 33) 88 86 68 54                                            
    Fax :  (00 33) 88 86 74 76                                            
   +-----------------------------------------------------------------------
    Project     : CF01                 Compiler   : TURBO PASCAL         
    Module name : MD03.PAS             Version    : 6.00                 
   +-------------------------------+---------------------------------------
    Author    : Francis GLOHR          Date       : 17 March 1994        
   +-----------------------------------------------------------------------
    Descript. :                                                           
                 Function to use the CF01 with MD03 modules               
   +-----------------------------------------------------------------------
                                UPDATES                                   
   +-----------------------------------------------------------------------
      Date      Author            Description of updates                
   +----------+-----------+------------------------------------------------
   17/03/94  F. Glohr    Creation V 1.00                                
   --------- -----------------------------------------------------------
   +-----------------------------------------------------------------------+}
program MD03;

uses Dos, Crt;

{  +-----------------------------------------------------------------------+
    Const definition                                                      
   +-----------------------------------------------------------------------+}

{ Base adress of the CF01 board is Hex 300 = Dec 768
  ****************************************************}

CONST
      AdrModule = $300;                         { Module is at position "A"     }
                                                { onto the CF01                 }


{ -------------------------------------------------------------------------
  Note: For over module position you must correct the constant ADRMODULE
        with the correct module adresse as specified in the CF01 handbook
        All bit are actuive low !!!
  -------------------------------------------------------------------------}





{  +-----------------------------------------------------------------------+
    Name :  MD03SetBit                                                    
   +-----------------------------------------------------------------------
    Description :                                                         
      Set 1 bit digital output                                            
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
             Bit       : INTEGER: Position of the output to write(1..8)   
   +-----------------------------------------------------------------------
    Output:                                                               
   +-----------------------------------------------------------------------+}
Procedure MD03SetBit (AdrModule : INTEGER; Bit : INTEGER);
Begin
   Port[AdrModule] := Port[AdrModule] OR (1 Shl (Bit-1));
End;

{  +-----------------------------------------------------------------------+
    Name :  MD03ResetBit                                                  
   +-----------------------------------------------------------------------
    Description :                                                         
      Reset 1 bit digital output                                          
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
             Bit       : INTEGER: Position of the output to write(1..8)   
   +-----------------------------------------------------------------------
    Output:                                                               
   +-----------------------------------------------------------------------+}
Procedure MD03ResetBit (AdrModule : INTEGER; Bit : INTEGER);
Begin
   Port[AdrModule] := Port[AdrModule] AND NOT (1 Shl (Bit-1));
End;

{  +-----------------------------------------------------------------------+
    Name :  MD03WriteOutput                                               
   +-----------------------------------------------------------------------
    Description :                                                         
      Write 8 bit digital output                                          
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
             Relais    : INTEGER: Value to write onto MD03                
   +-----------------------------------------------------------------------
    Output:                                                               
   +-----------------------------------------------------------------------+}
Procedure MD03WriteOutput (AdrModule : INTEGER; Relais : INTEGER);
Begin
   PORT[AdrModule] := Relais;
End;

{  +-----------------------------------------------------------------------+
    Name :  MD03ReadInput                                                 
   +-----------------------------------------------------------------------
    Description :                                                         
      Read current output value                                           
   +-----------------------------------------------------------------------
    Input :  AdrModule : INTEGER: Adress of the MD03 module (see Note)    
   +-----------------------------------------------------------------------
    Output:  INTEGER   : Relais status                                    
   +-----------------------------------------------------------------------+}
Function MD03ReadInput (AdrModule : INTEGER): INTEGER;
Begin
   MD03ReadInput := PORT[AdrModule];
End;

{  +-----------------------------------------------------------------------+
    Name :  main                                                          
   +-----------------------------------------------------------------------
    Description :                                                         
      Example to use the MD01 module                                      
   +-----------------------------------------------------------------------
    Input :                                                               
   +-----------------------------------------------------------------------
    Output:                                                               
   +-----------------------------------------------------------------------+}
Var
   k : Integer;
   i : Integer;
   l : Integer;

Begin

   ClrScr;
   GoToXY (10, 10); Write ('Example for use the MD03 module with the CF01 board');
   GoToXY (10, 11); Write ('-----------------------------------------------------');

   GoToXY (10, 25); Write ('Press a key to quit program');

   GoToXY (5, 14); Write ('+MSB-------------------------LSB+');
   GoToXY (5, 15); Write ('+-------------------------------+');
   GoToXY (5, 16); Write (' X  X  X  X  X  X  X  X ');
   GoToXY (5, 17); Write ('+-------------------------------+');


   MD03WriteOutput (AdrModule, $0);

   Repeat
      For i := 1 To 8 do Begin
         MD03SetBit   (AdrModule, i);
         l := MD03ReadInput (AdrModule);
         For k := 1 To 8 Do Begin
            GoToXY (3 + ((9 - k) * 4), 16);
            If l AND (1 SHL (K-1)) <> 0 Then Write ('1')
            Else Write ('0');
         End;

         Delay (500);
         MD03ResetBit (AdrModule, i);
      End;

   Until Keypressed;
End.
