DECLARE SUB MD06WriteOutput (AdrModule AS INTEGER, Relais AS INTEGER)
'  +-----------------------------------------------------------------------+
'   (C) SELIA design                                                      
'  +-----------------------------------------------------------------------
'   Tel :  (00 33) 88 86 68 54                                            
'   Fax :  (00 33) 88 86 74 76                                            
'  +-----------------------------------------------------------------------
'   Project     : CF01                 Compiler   : QBASIC               
'   Module name : MD06.PAS             Version    : 1.1                  
'  +-------------------------------+---------------------------------------
'   Author    : Francis GLOHR          Date       : 17 March 1994        
'  +-----------------------------------------------------------------------
'   Descript. :                                                           
'                Function to use the CF01 with MD06 modules               
'  +-----------------------------------------------------------------------
'                               UPDATES                                   
'  +-----------------------------------------------------------------------
'     Date      Author            Description of updates                
'  +----------+-----------+------------------------------------------------
'  17/03/94  F. Glohr    Creation V 1.00                                
'  --------- -----------------------------------------------------------
'  +-----------------------------------------------------------------------+

'  +-----------------------------------------------------------------------+
'   Const definition                                                      
'  +-----------------------------------------------------------------------+

' Base adress of the CF01 board is Hex 300 = Dec 768
' ***************************************************

CONST AdrModule = &H300                        ' Module is at position "A"
                                               ' onto the CF01            


' -------------------------------------------------------------------------
' Note: For over module position you must correct the constant ADRMODULE
'       with the correct module adresse as specified in the CF01 handbook
'  -------------------------------------------------------------------------


'  +-----------------------------------------------------------------------+
'   Name :  main                                                          
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Example to use the MD01 module                                      
'  +-----------------------------------------------------------------------
'   Input :                                                               
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
   CLS
   LOCATE 10, 10: PRINT ("Example for use the MD06 module with the CF01 board")
   LOCATE 11, 10: PRINT ("-----------------------------------------------------")



   MD06WriteOutput AdrModule, 0
   MD06WriteOutput AdrModule, &H55AA
   MD06WriteOutput AdrModule, &HAA55

END


'  +-----------------------------------------------------------------------+
'   Name :  MD06WriteOutput                                               
'  +-----------------------------------------------------------------------
'   Description :                                                         
'     Write 8 bit digital output                                          
'  +-----------------------------------------------------------------------
'   Input :  AdrModule : INTEGER: Adress of the MD06 module (see Note)    
'            Relais    : INTEGER: Value to write onto MD06                
'  +-----------------------------------------------------------------------
'   Output:                                                               
'  +-----------------------------------------------------------------------+}
SUB MD06WriteOutput (AdrModule AS INTEGER, Relais AS INTEGER)
   OUT AdrModule, Relais AND &HFF
   OUT AdrModule + 1, (Relais / 256)
END SUB

